Index: trunk/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- trunk/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 961)
+++ trunk/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 962)
@@ -2,5 +2,5 @@
  * Author : Gérald FENOY
  *
- *  Copyright 2008-2013 GeoLabs SARL. All rights reserved.
+ *  Copyright 2008-2020 GeoLabs SARL. All rights reserved.
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
@@ -63,10 +63,10 @@
 #include <string.h>
 
-#include "service.h"
-
 #include "service_internal.h"
 #include "server_internal.h"
 #include "response_print.h"
 #include "request_parser.h"
+#include "service.h"
+
 #ifdef USE_JSON
 #include "caching.h"
@@ -106,5 +106,5 @@
 #endif
 
-#ifdef USE_CALLBACK
+#if defined(USE_CALLBACK) || defined(USE_JSON)
 #include "service_callback.h"
 #endif
@@ -417,6 +417,12 @@
 	     _("Unable to parse the ZCFG file: %s."),
 	     zcfg);
+  
   map* errormap = createMap("text", tmp01);
-  addToMap(errormap,"code", code);
+  map* tmpMap=getMapFromMaps(m,"lenv","executionType");
+  char* errorCode=(char*)code;
+  if(tmpMap!=NULL && strncasecmp(tmpMap->value,"json",4)==0)
+    errorCode="NoSuchProcess";
+
+  addToMap(errormap,"code", errorCode);
   addToMap(errormap,"locator", locator);
   funcError(m,errormap);
@@ -685,4 +691,5 @@
   fflush (stdout);
   zDup2 (saved_stdout, fileno (stdout));
+  zClose(saved_stdout);
   free (orig);
   return 0;
@@ -1870,10 +1877,20 @@
 #endif
   }
-  
+
+  int eres = SERVICE_STARTED;
+  int cpid = zGetpid ();
+  maps* bmap=NULL;
+  char *fbkp, *fbkpid, *fbkpres, *fbkp1, *flog;
+  FILE *f0, *f1;
+  HINTERNET hInternet;
+  service *s1;
+  maps *request_output_real_format = NULL;
+  maps *request_input_real_format = NULL;
+
   setMapInMaps(m,"lenv","executionType","xml");
-  if((strlen(cgiQueryString)>0 && cgiQueryString[0]=='/') && strstr(cgiAccept,"json")!=NULL){
-  //
-  // OGC API - Processing starts here
-  //
+  if((strlen(cgiQueryString)>0 && cgiQueryString[0]=='/') /*&& strstr(cgiAccept,"json")!=NULL*/){
+    //
+    // OGC API - Processing starts here
+    //
 #ifndef USE_JSON
     errorException (m, _("OGC API - Processing is not supported by this ZOO-Kernel."), "InternalError", NULL);
@@ -1904,5 +1921,24 @@
     addMapsToMaps(&m,m1);
     setMapInMaps(m,"lenv","executionType","json");
-
+    map* pmTmp0=getMapFromMaps(m,"openapi","full_html_support");
+    dumpMap(pmTmp0);
+    if(strstr(cgiQueryString,".html")==NULL && strstr(cgiAccept,"text/html")!=NULL && pmTmp0!=NULL && strncasecmp(pmTmp0->value,"true",4)==0){
+      map* pmTmpUrl=getMapFromMaps(m,"openapi","rootUrl");
+      char* pacTmpUrl=NULL;
+      if(strcmp(cgiQueryString,"/")!=0){
+	 pacTmpUrl=(char*)malloc((strlen(cgiQueryString)+strlen(pmTmpUrl->value)+6)*sizeof(char));
+	 sprintf(pacTmpUrl,"%s%s.html",pmTmpUrl->value,cgiQueryString);
+      }
+      else{
+	pacTmpUrl=(char*)malloc((strlen(pmTmpUrl->value)+6)*sizeof(char));
+	sprintf(pacTmpUrl,"%s/index.html",pmTmpUrl->value);
+      }
+      setMapInMaps(m,"headers","Location",pacTmpUrl);
+      printHeaders(m);
+      printf("Status: 302 Moved permanently \r\n\r\n");
+      fflush(stdout);
+      free(pacTmpUrl);
+      return 1;
+    }
     json_object *res=json_object_new_object();
     setMapInMaps(m,"headers","Content-Type","application/json;charset=UTF-8");
@@ -1917,20 +1953,58 @@
       for(int kk=0;kk<4;kk++){
 	maps* tmpMaps=getMaps(m,urls[kk]);
-	json_object *res2;
 	if(tmpMaps!=NULL){
+	  json_object *res2;
 	  res2=mapToJson(tmpMaps->content);
 	  char* tmpStr=(char*) malloc((strlen(tmpUrl->value)+strlen(urls[kk])+2)*sizeof(char));
 	  sprintf(tmpStr,"%s%s",tmpUrl->value,urls[kk]);
 	  json_object_object_add(res2,"href",json_object_new_string(tmpStr));
+	  free(tmpStr);
 	  json_object_array_add(res1,res2);
+
+	  map* pmTmp=getMap(tmpMaps->content,"title");
+	  char *pacTitle=NULL;
+	  if(pmTmp!=NULL)
+	    pacTitle=zStrdup(pmTmp->value);
+	  char* pacTmp=(char*) malloc((strlen(urls[kk])+6)*sizeof(char));
+	  sprintf(pacTmp,"%s.html",urls[kk]);
+	  tmpMaps=getMaps(m,pacTmp);
+	  if(tmpMaps==NULL && strncasecmp(pacTmp,"/.html",6)==0)
+	    tmpMaps=getMaps(m,"/index.html");
+	  if(tmpMaps!=NULL){
+	    json_object *res3;
+	    res3=mapToJson(tmpMaps->content);
+	    if(getMap(tmpMaps->content,"title")==NULL && pacTitle!=NULL){
+	      json_object_object_add(res3,"title",json_object_new_string(pacTitle));
+	    }
+	    char* tmpStr=NULL;
+	    if(strncasecmp(pacTmp,"/.html",6)==0){
+	      tmpStr=(char*) malloc((strlen(tmpUrl->value)+12)*sizeof(char));
+	      sprintf(tmpStr,"%s/index.html",tmpUrl->value);
+	    }else{
+	      tmpStr=(char*) malloc((strlen(tmpUrl->value)+strlen(urls[kk])+6)*sizeof(char));
+	      sprintf(tmpStr,"%s%s.html",tmpUrl->value,urls[kk]);
+	    }
+	    json_object_object_add(res3,"href",json_object_new_string(tmpStr));
+	    free(tmpStr);
+	    json_object_array_add(res1,res3);
+	  }
+	  free(pacTmp);
+	  if(pacTitle!=NULL)
+	    free(pacTitle);	  
 	}
       }
+      map* pmTmp=getMapFromMaps(m,"identification","title");
+      if(pmTmp!=NULL)
+	json_object_object_add(res,"title",json_object_new_string(pmTmp->value));
+      pmTmp=getMapFromMaps(m,"identification","abstract");
+      if(pmTmp!=NULL)
+	json_object_object_add(res,"description",json_object_new_string(pmTmp->value));
       json_object_object_add(res,"links",res1);
     }else if(strcmp(cgiQueryString,"/conformance")==0){
       /* - /conformance url */
-      map* rootUrl=getMapFromMaps(m,"conformTo","rootUrl");
+      map* rootUrl=getMapFromMaps(m,"conformsTo","rootUrl");
       json_object *res1=json_object_new_array();
-      map* length=getMapFromMaps(m,"conformTo","length");
-      maps* tmpMaps=getMaps(m,"conformTo");
+      map* length=getMapFromMaps(m,"conformsTo","length");
+      maps* tmpMaps=getMaps(m,"conformsTo");
       for(int kk=0;kk<atoi(length->value);kk++){
 	map* tmpMap1=getMapArray(tmpMaps->content,"link",kk);
@@ -1942,15 +2016,23 @@
 	}
       }
-      json_object_object_add(res,"conformTo",res1);
-    }else if(strcmp(cgiQueryString,"/api")==0){
-      /* - /api url */
-      produceApi(m,res);
+      json_object_object_add(res,"conformsTo",res1);
+    }else if(strncasecmp(cgiQueryString,"/api",4)==0){
+      if(strstr(cgiQueryString,".html")==NULL)
+	produceApi(m,res);
+      else{	
+	char* pacTmp=(char*)malloc(9*sizeof(char));
+	sprintf(pacTmp,"%s",cgiQueryString+1);
+	map* pmTmp=getMapFromMaps(m,pacTmp,"href");
+	free(pacTmp);
+	if(pmTmp!=NULL)
+	  setMapInMaps(m,"headers","Location",pmTmp->value);
+      }	
     }else if(strcmp(cgiQueryString,"/processes")==0 || strcmp(cgiQueryString,"/processes/")==0){
       /* - /processes */
+      setMapInMaps(m,"lenv","requestType","desc");
       json_object *res3=json_object_new_array();
       int saved_stdout = zDup (fileno (stdout));
       zDup2 (fileno (stderr), fileno (stdout));
-
-      if (int res =		  
+      if (int res0 =		  
           recursReaddirF (m, NULL, res3, NULL, ntmp, NULL, saved_stdout, 0,
 			  printGetCapabilitiesForProcessJ) < 0)
@@ -1959,6 +2041,6 @@
       zDup2 (saved_stdout, fileno (stdout));
       zClose(saved_stdout);
-      
-      json_object_object_add(res,"processes",res3);
+      res=res3;
+      //json_object_object_add(res,"processes",res3);
     }else{
       service* s1=NULL;
@@ -1984,4 +2066,5 @@
 	    orig[strlen(orig)-1]=0;
 	  json_object* res1=json_object_new_object();
+	  setMapInMaps(m,"lenv","requestType","GetCapabilities");
 	  int t=fetchServicesForDescription(NULL, m, orig,
 					    printGetCapabilitiesForProcessJ,
@@ -1991,6 +2074,6 @@
 	  if(t==1){
 	    /*map* error=createMap("code","BadRequest");
-	    addToMap(error,"message",_("Failed to acces the requested service"));
-	    printExceptionReportResponseJ(m,error);*/
+	      addToMap(error,"message",_("Failed to acces the requested service"));
+	      printExceptionReportResponseJ(m,error);*/
 	    return 1;
 	  }
@@ -2003,5 +2086,4 @@
 	  int cnt=0;
 	  for(int j=11;j<len1;j++){
-	    fprintf(stderr,"%s %c\n",cIdentifier,cgiQueryString[j]);
 	    cIdentifier[cnt]=cgiQueryString[j];
 	    cIdentifier[cnt+1]=0;
@@ -2009,5 +2091,4 @@
 	  }
 	  char tmps1[1024];
-
 	  map* import = getMapFromMaps (m, IMPORTSERVICE, cIdentifier); 
 	  if (import != NULL && import->value != NULL) { 
@@ -2023,4 +2104,5 @@
 	    if (strstr (cIdentifier, ".") != NULL)
 	      {
+		setMapInMaps (m, "lenv", "oIdentifier", cIdentifier);
 		char *identifier = zStrdup (cIdentifier);
 		parseIdentifier (m, ntmp, identifier, tmps1);
@@ -2071,5 +2153,5 @@
 		map* error=createMap("code","InternalError");
 		addToMap(error,"message",_("Unable to allocate memory"));
-		//setMapInMaps(conf,"lenv","status_code","404 Bad Request");
+		setMapInMaps(m,"lenv","status_code","404 Bad Request");
 		printExceptionReportResponseJ(m,error);
 
@@ -2091,49 +2173,166 @@
 	      free(zooRegistry);
 	    }
+	    fflush(stderr);
 	    fflush (stdout);
 	    zDup2 (saved_stdout, fileno (stdout));
+	    zClose (saved_stdout);
 	    if (t < 0)
 	      {
-		char *tmpMsg = (char *) malloc (2048 + strlen (r_inputs->value));
-		sprintf (tmpMsg,
-			 _
-			 ("The value for <identifier> seems to be wrong (%s). Please specify one of the processes in the list returned by a GetCapabilities request."),
-			 r_inputs->value);
-		map* error=createMap("code","InvalidParameterValue");
-		addToMap(error,"message",tmpMsg);
-		//setMapInMaps(conf,"lenv","status_code","404 Bad Request");
-		printExceptionReportResponseJ(m,error);
-
-		//errorException (m, tmpMsg, "InvalidParameterValue", "identifier");
-		free (tmpMsg);
-		free (s1);
-		freeMaps (&m);
-		free (m);
-		free (REQUEST);
-		free (SERVICE_URL);
-		return 0;
+		r_inputs = getMapFromMaps (m, "lenv", "oIdentifier");
+		if(r_inputs!=NULL){
+		  char *tmpMsg = (char *) malloc (2048 + strlen (r_inputs->value));
+		  sprintf (tmpMsg,
+			   _
+			   ("The value for <identifier> seems to be wrong (%s). Please specify one of the processes in the list returned by a GetCapabilities request."),
+			   r_inputs->value);
+		  map* error=createMap("code","NoSuchProcess");
+		  addToMap(error,"message",tmpMsg);
+		  //setMapInMaps(conf,"lenv","status_code","404 Bad Request");
+		  printExceptionReportResponseJ(m,error);
+
+		  //errorException (m, tmpMsg, "InvalidParameterValue", "identifier");
+		  free (tmpMsg);
+		  free (s1);
+		  freeMaps (&m);
+		  free (m);
+		  free (REQUEST);
+		  free (SERVICE_URL);
+		  return 0;
+		}
 	      }
-	    zClose (saved_stdout);
-	  
 #ifdef META_DB
 	  }
 #endif
-	  if(strstr(cgiQueryString,"/jobs/")!=NULL && strlen(strstr(cgiQueryString,"/jobs/"))>6){
+	  if(strstr(cgiQueryString,"/jobs/")!=NULL && strlen(strstr(cgiQueryString,"/jobs/"))>6) {
 	    /* - /jobs/{jobID} and /jobs/{jobID}/result urls */
-	    if(strstr(cgiQueryString,"/result")!=NULL && strlen(strstr(cgiQueryString,"/result"))>=7){
-	      fprintf(stderr,"For GetResult %s %d \n",__FILE__,__LINE__);
+	    if(strstr(cgiQueryString,"/results")!=NULL){
+	      // In case the service has run, then forward request to target result file
+	      char* jobId=zStrdup(strstr(cgiQueryString,"/jobs/")+6);
+	      jobId[strlen(jobId)-8]=0;
+	      char *sid=getStatusId(m,jobId);
+	      if(sid==NULL){
+		map* error=createMap("code","NoSuchJob");
+		addToMap(error,"message",_("The JobID from the request does not match any of the Jobs running on this server"));
+		printExceptionReportResponseJ(m,error);
+		return 1;
+	      }else{
+		if(isRunning(m,jobId)>0){
+		  map* error=createMap("code","ResultNotReady");
+		  addToMap(error,"message",_("The job is still running."));
+		  printExceptionReportResponseJ(m,error);
+		  return 1;
+		}else{
+		  char *Url0=getResultPath(m,jobId);
+		  map *cIdentifier = getMapFromMaps (m, "lenv", "oIdentifier");
+		  zStatStruct f_status;
+		  int s=zStat(Url0, &f_status);
+		  if(s==0 && f_status.st_size>0){
+		    if(f_status.st_size>15){
+		      json_object* pjoTmp=json_readFile(m,Url0);
+		      json_object* pjoCode=NULL;
+		      json_object* pjoMessage=NULL;
+		      if(pjoTmp!=NULL &&
+			 json_object_object_get_ex(pjoTmp,"code",&pjoCode)!=FALSE &&
+			 json_object_object_get_ex(pjoTmp,"description",&pjoMessage)!=FALSE){
+			map* error=createMap("code",json_object_get_string(pjoCode));
+			addToMap(error,"message",json_object_get_string(pjoMessage));
+			printExceptionReportResponseJ(m,error);
+			return 1;			
+		      }else{
+
+			map* tmpPath = getMapFromMaps (m, "main", "tmpUrl");
+			Url0=(char*) realloc(Url0,(strlen(tmpPath->value)+
+						   strlen(cIdentifier->value)+
+						   strlen(jobId)+8)*sizeof(char));
+			sprintf(Url0,"%s/%s_%s.json",tmpPath->value,
+				cIdentifier->value,jobId);
+			setMapInMaps(m,"headers","Location",Url0);
+		      }
+		      free(Url0);
+		    }else{
+		      // Service Failed
+		      map* statusInfo=createMap("JobID",jobId);
+		      readFinalRes(m,jobId,statusInfo);
+		      {
+			map* pmStatus=getMap(statusInfo,"status");
+			if(pmStatus!=NULL)
+			  setMapInMaps(m,"lenv","status",pmStatus->value);
+		      }
+		      char* tmpStr=_getStatus(m,jobId);
+		      if(tmpStr!=NULL && strncmp(tmpStr,"-1",2)!=0){
+			char *tmpStr1=zStrdup(tmpStr);
+			char *tmpStr0=zStrdup(strstr(tmpStr,"|")+1);
+			free(tmpStr);
+			tmpStr1[strlen(tmpStr1)-strlen(tmpStr0)-1]='\0';
+			addToMap(statusInfo,"PercentCompleted",tmpStr1);
+			addToMap(statusInfo,"Message",tmpStr0);
+			setMapInMaps(m,"lenv","PercentCompleted",tmpStr1);
+			setMapInMaps(m,"lenv","Message",tmpStr0);
+			free(tmpStr0);
+			free(tmpStr1);
+		      }
+		      map* error=createMap("code","NoApplicableCode");
+		      addToMap(error,"message",_("The service failed to execute."));
+		      printExceptionReportResponseJ(m,error);
+		      return 1;
+		    }
+
+		  }else{
+		    map* error=createMap("code","NoSuchJob");
+		    addToMap(error,"message",_("The JobID seem to be running on this server but not for this process id"));
+		    printExceptionReportResponseJ(m,error);
+		    return 1;
+		  }
+		}
+	      }
 	    }else{
 	      char* tmpUrl=strstr(cgiQueryString,"/jobs/");
 	      if(tmpUrl!=NULL && strlen(tmpUrl)>6){
-		char* jobId=zStrdup(strstr(cgiQueryString,"/jobs/")+6);
-		setMapInMaps(m,"lenv","gs_usid",jobId);
-		json_getStatusFile(m);
-		free(jobId);
-		return 1;	      
+		if(strncasecmp(cgiRequestMethod,"DELETE",6)==0){
+		  char* jobId=zStrdup(strstr(cgiQueryString,"/jobs/")+6);
+		  setMapInMaps(m,"lenv","gs_usid",jobId);
+		  setMapInMaps(m,"lenv","file.statusFile",json_getStatusFilePath(m));
+		  runDismiss(m,jobId);
+		  map* pmError=getMapFromMaps(m,"lenv","error");
+		  if(pmError!=NULL && strncasecmp(pmError->value,"true",4)==0){
+		    printExceptionReportResponseJ(m,getMapFromMaps(m,"lenv","code"));
+		    return 1;
+		  }
+		  else{
+		    setMapInMaps(m,"lenv","gs_location","false");
+		    res=createStatus(m,SERVICE_DISMISSED);
+		  }
+		}else{
+		  char* jobId=zStrdup(strstr(cgiQueryString,"/jobs/")+6);
+		  runGetStatus(m,jobId,"GetStatus");
+		  map* pmError=getMapFromMaps(m,"lenv","error");
+		  if(pmError!=NULL && strncasecmp(pmError->value,"true",4)==0){
+		    printExceptionReportResponseJ(m,getMapFromMaps(m,"lenv","code"));
+		    return 1;
+		  }else{
+		    map* pmStatus=getMapFromMaps(m,"lenv","status");
+		    setMapInMaps(m,"lenv","gs_location","false");
+		    setMapInMaps(m,"lenv","gs_usid",jobId);
+		    if(pmStatus!=NULL && strncasecmp(pmStatus->value,"Failed",6)==0)
+		      res=createStatus(m,SERVICE_FAILED);
+		    else
+		      if(pmStatus!=NULL  && strncasecmp(pmStatus->value,"Succeeded",9)==0)
+			res=createStatus(m,SERVICE_SUCCEEDED);
+		      else
+			if(pmStatus!=NULL  && strncasecmp(pmStatus->value,"Running",7)==0){
+			  map* tmpMap=getMapFromMaps(m,"lenv","Message");
+			  if(tmpMap!=NULL)
+			    setMapInMaps(m,"lenv","gs_message",tmpMap->value);
+			  res=createStatus(m,SERVICE_STARTED);
+			}
+			else
+			  res=createStatus(m,SERVICE_FAILED);
+		  }
+		  free(jobId);
+		}
 	      }
 	    }
 	  }else{
 	    /* - /jobs url */
-	    fprintf(stderr,"For Execute or Job list %s %d \n",__FILE__,__LINE__);
 	    if(strcasecmp(cgiRequestMethod,"get")==0){
 	      /* - /jobs List (GET) */
@@ -2141,6 +2340,5 @@
 	    }else if(strcasecmp(cgiRequestMethod,"post")==0){
 	      /* - /jobs Execution (POST) */
-	      int eres = SERVICE_STARTED;
-
+	      eres = SERVICE_STARTED;
 	      initAllEnvironment(m,request_inputs,ntmp,"jrequest");
 	      map* req=getMapFromMaps(m,"renv","jrequest");
@@ -2156,19 +2354,31 @@
 	      } while ((jerr = json_tokener_get_error(tok)) == json_tokener_continue);
 	      if (jerr != json_tokener_success) {
+		map* pamError=createMap("code","InvalidParameterValue");
+		const char* pcTmpErr=json_tokener_error_desc(jerr);
+		const char* pccErr=_("ZOO-Kernel cannot parse your POST data: %s");
+		char* pacMessage=(char*)malloc((strlen(pcTmpErr)+strlen(pccErr)+1)*sizeof(char));
+		sprintf(pacMessage,pccErr,pcTmpErr);
+		addToMap(pamError,"message",pacMessage);
+		printExceptionReportResponseJ(m,pamError);
 		fprintf(stderr, "Error: %s\n", json_tokener_error_desc(jerr));
 		return 1;
 	      }
 	      if (tok->char_offset < slen){
+		map* pamError=createMap("code","InvalidParameterValue");
+		const char* pcTmpErr="None";
+		const char* pccErr=_("ZOO-Kernel cannot parse your POST data: %s");
+		char* pacMessage=(char*)malloc((strlen(pcTmpErr)+strlen(pccErr)+1)*sizeof(char));
+		sprintf(pacMessage,pccErr,pcTmpErr);
+		addToMap(pamError,"message",pacMessage);
+		printExceptionReportResponseJ(m,pamError);
+		fprintf(stderr, "Error: %s\n", json_tokener_error_desc(jerr));
 		return 1;
 	      }
-	      fprintf(stderr,"%s %d \n",__FILE__,__LINE__);
-	      // Success, use jobj here.
-	      maps* inputs_real_format=NULL, *outputs_real_format= NULL;
-	      parseJRequest(m,s1,jobj,&inputs_real_format,&outputs_real_format);
+	      //maps* inputs_real_format=NULL, *outputs_real_format= NULL;
+	      parseJRequest(m,s1,jobj,request_inputs,&request_input_real_format,&request_output_real_format);
 	      map* preference=getMapFromMaps(m,"renv","HTTP_PREFER");
-	      if(preference!=NULL && strcasecmp(preference->value,"respond-async")==0){
-		fprintf(stderr,"Asynchronous call!\n");
-		char *fbkp, *fbkpid, *fbkpres, *fbkp1, *flog;
-		FILE *f0, *f1;
+	      map* mode=getMap(request_inputs,"mode");
+	      if((preference!=NULL && strcasecmp(preference->value,"respond-async")==0) ||
+		 (mode!=NULL && strncasecmp(mode->value,"async",5)==0)) {
 		int pid;
 #ifdef DEBUG
@@ -2204,4 +2414,5 @@
 		    eres = SERVICE_ACCEPTED;
 		    createStatusFile(m,eres);
+		    //invokeBasicCallback(m,SERVICE_ACCEPTED);
 		    printHeaders(m);
 		    printf("Status: 201 Created \r\n\r\n");
@@ -2215,4 +2426,5 @@
 		    // process answer to http client.
 		    //
+		    map* oid = getMapFromMaps (m, "lenv", "oIdentifier");
 		    map* usid = getMapFromMaps (m, "lenv", "uusid");
 		    map* tmpm = getMapFromMaps (m, "lenv", "osid");
@@ -2228,5 +2440,5 @@
 			       strlen (usid->value) + 7) * sizeof (char));                    
 		    sprintf (fbkpres, "%s/%s.res", r_inputs->value, usid->value);
-		    maps* bmap = createMaps("status");
+		    bmap = createMaps("status");
 		    bmap->content=createMap("usid",usid->value);
 		    addToMap(bmap->content,"sid",tmpm->value);
@@ -2248,5 +2460,5 @@
 		    fbkp =
 		      (char *)
-		      malloc ((strlen (r_inputs->value) + strlen (r_inputs1->value) +
+		      malloc ((strlen (r_inputs->value) + strlen (oid->value) +
 			       strlen (usid->value) + 7) * sizeof (char));
 		    sprintf (fbkp, "%s/%s.sid", r_inputs->value, usid->value);
@@ -2259,15 +2471,15 @@
 		    fbkp =
 		      (char *)
-		      malloc ((strlen (r_inputs->value) + strlen (r_inputs1->value) +
+		      malloc ((strlen (r_inputs->value) + strlen (oid->value) +
 			       strlen (usid->value) + 7) * sizeof (char));
-		    sprintf (fbkp, "%s/%s_%s.xml", r_inputs->value, r_inputs1->value,
+		    sprintf (fbkp, "%s/%s_%s.json", r_inputs->value, oid->value,
 			     usid->value);
 		    setMapInMaps (m, "lenv", "file.responseInit", fbkp);
 		    flog =
 		      (char *)
-		      malloc ((strlen (r_inputs->value) + strlen (r_inputs1->value) +
+		      malloc ((strlen (r_inputs->value) + strlen (oid->value) +
 			       strlen (usid->value) + 13) * sizeof (char));
 		    sprintf (flog, "%s/%s_%s_error.log", r_inputs->value,
-			     r_inputs1->value, usid->value);
+			     oid->value, usid->value);
 		    setMapInMaps (m, "lenv", "file.log", flog);
 #ifdef DEBUG
@@ -2291,16 +2503,12 @@
 		    invokeCallback(m,NULL,NULL,0,0);
 #endif
-		    fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
-		    fflush(stderr);
-		    
-		    createStatusFile(m,eres);
-		    	  
-		  
+		    invokeBasicCallback(m,SERVICE_STARTED);
+		    createStatusFile(m,SERVICE_STARTED);
 		    fbkp1 =
 		      (char *)
-		      malloc ((strlen (r_inputs->value) + strlen (r_inputs1->value) +
+		      malloc ((strlen (r_inputs->value) + strlen (oid->value) +
 			       strlen (usid->value) + 15) * sizeof (char));
 		    sprintf (fbkp1, "%s/%s_final_%s.json", r_inputs->value,
-			     r_inputs1->value, usid->value);
+			     oid->value, usid->value);
 		    setMapInMaps (m, "lenv", "file.responseFinal", fbkp1);
 
@@ -2317,32 +2525,31 @@
 		    sprintf (flenv, "%s/%s_lenv.cfg", r_inputs->value, usid->value);
 		    maps* lenvMaps=getMaps(m,"lenv");
-		    dumpMapsToFile(lenvMaps,flenv,0);
+		    dumpMapsToFile(lenvMaps,flenv,1);
 		    free(flenv);
 
 		    map* testMap=getMapFromMaps(m,"main","memory");
-		    loadHttpRequests(m,inputs_real_format);
+		    loadHttpRequests(m,request_input_real_format);
+		    dumpMaps(request_input_real_format);
 		    loadServiceAndRun (&m, s1, request_inputs,
-				       &inputs_real_format,
-				       &outputs_real_format, &eres);
+				       &request_input_real_format,
+				       &request_output_real_format, &eres);
+		    setMapInMaps(m,"lenv","force","true");
 		    createStatusFile(m,eres);
-		    res=printJResult(m,s1,outputs_real_format,eres);
-		    char tmpUrl0[1024];
-		    const char* jsonStr=json_object_to_json_string_ext(res,JSON_C_TO_STRING_PLAIN);
-		    printf(jsonStr);
-		    printf("\n");
-		    return 1;
-
+		    setMapInMaps(m,"lenv","force","false");
+		    setMapInMaps(m,"lenv","no-headers","true");
+		    fflush(stdout);
+		    rewind(stdout);
+		    res=printJResult(m,s1,request_output_real_format,eres);
+		    const char* jsonStr0=json_object_to_json_string_ext(res,JSON_C_TO_STRING_PLAIN);
+		    if(getMapFromMaps(m,"lenv","jsonStr")==NULL)
+		      setMapInMaps(m,"lenv","jsonStr",jsonStr0);
+		    invokeBasicCallback(m,eres);
 		  }
 	      }else{
-		loadHttpRequests(m,inputs_real_format);
-		loadServiceAndRun (&m,s1,request_inputs,&inputs_real_format,&outputs_real_format,&eres);
-		res=printJResult(m,s1,outputs_real_format,eres);
-	      
-		printHeaders(m);
-		printf("Status: 201 Created \r\n\r\n");
-		const char* jsonStr=json_object_to_json_string_ext(res,JSON_C_TO_STRING_PLAIN);
-		printf(jsonStr);
-		printf("\n");
-		return 1;
+		loadHttpRequests(m,request_input_real_format);
+		loadServiceAndRun (&m,s1,request_inputs,
+				   &request_input_real_format,
+				   &request_output_real_format,&eres);
+		res=printJResult(m,s1,request_output_real_format,eres);
 	      }
 
